import type { GetServerSideProps, NextPage } from "next";
import Head from "next/head";
import { useRouter } from "next/router";
import { FormEvent, useEffect, useState } from "react";
import BlogItem, { BlogItemType } from "../../components/BlogItem";
import PageTitle from "../../components/PageTitle";

interface Props {
  blogsData: BlogItemType[]
}

const Blog: NextPage<Props> = ({ blogsData }) => {
  const router = useRouter()
  const { query } = useRouter()

  const [data, setData] = useState(blogsData)


  useEffect(() => {
    setData(blogsData)
  }, [query])

  const [searchValue, setSearchValue] = useState('')

  const onSubmit = (e: FormEvent) => {
    e.preventDefault()
    delete query.search
    router.push({
      query: {
        ...router.query,
        search: searchValue
      }
    })
    setSearchValue('')       
  }
  return (
    <>
      <Head>
        <title>Store - Blog</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>

      <PageTitle title="Blog" />

      <section className="bg0 p-t-62 p-b-60">
        <div className="container">
          <div className="row">
            <div className="col-md-8 col-lg-9 p-b-80">
              <div className="p-r-45 p-r-0-lg">
                {/* blog item */}
                {data.length ? data.map(i => (
                  <BlogItem item={i} key={i.id} />
                )) : <p>There are no results with your search.</p>}
              </div>
            </div>

            <div className="col-md-4 col-lg-3 p-b-80">
              <div className="side-menu">
                <form className="bor17 of-hidden pos-relative"
                  onSubmit={onSubmit}

                >
                  <input
                    className="stext-103 cl2 plh4 size-116 p-l-28 p-r-55"
                    type="text"
                    name="search"
                    placeholder="Search"
                    value={searchValue}
                    onChange={(e) => setSearchValue(e.target.value)}
                  />

                  <button className="flex-c-m size-122 ab-t-r fs-18 cl4 hov-cl1 trans-04"
                  >
                    <i className="zmdi zmdi-search"></i>
                  </button>
                </form>

                <div className="p-t-55">
                  <h4 className="mtext-112 cl2 p-b-33">Categories</h4>

                  <ul>
                    <li className="bor18">
                      <button className="dis-block stext-115 cl6 hov-cl1 trans-04 p-tb-8 p-lr-4"
                        onClick={() => {
                          delete query.category
                          router.push({
                            query: {
                              ...router.query,
                              category_like: "fashion"
                            }
                          })
                        }}>
                        Fashion
                      </button>
                    </li>

                    <li className="bor18">
                      <button className="dis-block stext-115 cl6 hov-cl1 trans-04 p-tb-8 p-lr-4"
                        onClick={() => {
                          delete query.category
                          router.push({
                            query: {
                              ...router.query,
                              category_like: 'beauty'
                            }
                          })
                        }}>
                        Beauty
                      </button>
                    </li>

                    <li className="bor18">
                      <button className="dis-block stext-115 cl6 hov-cl1 trans-04 p-tb-8 p-lr-4"
                        onClick={() => {
                          delete query.category
                          router.push({
                            query: {
                              ...router.query,
                              category_like: 'streetstyle'
                            }
                          })
                        }}>
                        Street Style
                      </button>
                    </li>

                    <li className="bor18">
                      <button className="dis-block stext-115 cl6 hov-cl1 trans-04 p-tb-8 p-lr-4"
                        onClick={() => {
                          delete query.category
                          router.push({
                            query: {
                              ...router.query,
                              category_like: 'lifestyle'
                            }
                          })
                        }}>
                        Life Style
                      </button>
                    </li>

                    <li className="bor18">
                      <button className="dis-block stext-115 cl6 hov-cl1 trans-04 p-tb-8 p-lr-4"
                        onClick={() => {
                          delete query.category
                          router.push({
                            query: {
                              ...router.query,
                              category_like: 'diy'
                            }
                          })
                        }}>
                        DIY & Crafts
                      </button>
                    </li>
                  </ul>
                </div>
              </div>
            </div>
          </div>
        </div>
      </section>
    </>
  );
};

export const getServerSideProps: GetServerSideProps = async ({ query }) => {
  const { category_like, search } = query

  const res = await fetch(`https://boutique-server-api.herokuapp.com/blogs?${search && `q=${search}`}&${query.category_like && `category_like=${category_like}`}`)
  const blogsData = await res.json()

  return {
    props: {
      blogsData
    }
  }
}

export default Blog;
